=== modified file '.bzrignore'
--- .bzrignore	2010-03-23 15:44:51 +0000
+++ .bzrignore	2009-04-01 14:40:05 +0000
@@ -7,5 +7,3 @@
 *.log
 _trial_temp
 loggerhead-memprofile
-docs/_build/doctrees
-docs/_build/html

=== modified file 'NEWS'
--- NEWS	2010-02-26 04:38:23 +0000
+++ NEWS	2009-05-27 12:51:51 +0000
@@ -2,24 +2,8 @@
 =============================
 
 dev [future]
-------------
-
-    - Show svn/git/hg revision ids in loggerhead revision view.
-      (Jelmer Vernooij)
-
-    - Fix .bzr/smart access to branches in shared repos. (You also need
-      a version of bzr with bug #348308 fixed.) (Andrew Bennetts)
-
-    - Support FastCGI, SCGI and AJP using flup. (Denis Martinez)
-
-    - Repository.get_revision_inventory() was removed in bzr 2.2; use
-      Repository.get_inventory() instead. (Matt Nordhoff, #528194)
-
-1.17 [20Aug2009]
 ---------------
 
-    - Add bug links in revision informations (Alexandre Garnier, #314052)
-
     - Make sure that binary files aren't annotated. (Martin Albisetti,
       #258848)
 
@@ -134,39 +118,6 @@
     - Added the option to hide branches by setting http_serve = False
       in locations.conf (Martin Albisetti)
 
-    - Fix serving branches over HTTP. (Matt Nordhoff, Jelmer Vernooij,
-      #380026)
-
-    - Install loggerhead as a bzr plugin by default (Jelmer Vernooij)
-
-    - Fix logging 404 Not Found responses (Matt Nordhoff, #381029)
-
-    - Bumped minimunm bzrlib version to 1.13 (Martin Albisetti)
-
-    - Make sure the Atom feeds (nearly) validate. (Matt Nordhoff, #247162)
-
-    - Support serving branches over HTTP using the smart server protocol.
-      (Jelmer Vernooij, #306853)
-
-    - Serving branch data was broken when --allow-writes was *not*
-      passed. (Michael Hudson, #388730)
-
-    - http_serve config values are interpreted more forgivingly.
-      (Michael Hudson)
-
-    - When specifying a remote url to serve-branches, do not share
-      connections between threads. (Michael Hudson, #390972)
-
-    - http_serve values from locations.conf are now applied to
-      non-branch .bzr data (e.g shared repositories). (Michael Hudson)
-
-    - tags are now displayed. (Cris Boylan, Alexandre Garnier, Michael
-      Hudson, #246739)
-
-    - Display Loggerhead's version number at the bottom of the page, and
-      add a <meta> generator tag also including the version numbers of
-      its dependencies. (Matt Nordhoff, #370155)
-
 
 1.10 [22Dec2008]
 ---------------

=== renamed file 'README' => 'README.txt'
--- README	2009-11-27 18:06:53 +0000
+++ README.txt	2009-05-27 12:51:51 +0000
@@ -1,7 +1,7 @@
 LOGGERHEAD
 ==========
 
-[ Version 1.17 for Bazaar 1.17 ]
+[ Version 1.10 for Bazaar 1.6 ]
 
 Loggerhead is a web viewer for Bazaar branches.  It can be used to
 navigate a branch history, annotate files, perform searches... all the
@@ -25,9 +25,6 @@
 4) Paste Deploy  (optional, needed when proxying through Apache)
    On Ubuntu, `sudo apt-get install python-pastedeploy`
    or use `easy_install PasteDeploy`
-5) flup (optional, needed to use FastCGI, SCGI or AJP)
-   On Ubuntu, `sudo apt-get install python-flup`
-   or use `easy_install flup`
 
 Then simply run the 'serve-branches' with the branch you want to
 serve on the command line:
@@ -43,7 +40,7 @@
 Loggerhead will notice and refresh, and Bazaar uses its own branch
 locking to prevent corruption.
 
-To run loggerhead as a linux daemon:
+To run loggerhead as a linux daemon: 
 1) Copy loggerheadd to /etc/init.d
 2) Edit the file to configure where your loggerhead is installed, and which
    serve-branches options you would like.
@@ -102,7 +99,6 @@
 You need to have the plugin installed and each branch indexed to allow
 searching on branches.
 
-
 SUPPORT
 -------
 
@@ -116,12 +112,3 @@
 Bugs are tracked on Launchpad; start at:
 
     https://bugs.launchpad.net/loggerhead
-
-
-HACKING
--------
-
-To run loggerhead tests, you will need the package python-nose,
-and run in the loggerhead directory:
-
-    nosetests

=== modified file '__init__.py'
--- __init__.py	2009-10-17 06:35:33 +0000
+++ __init__.py	2009-05-17 13:03:04 +0000
@@ -30,93 +30,66 @@
 starts a web server to browse the contents of a branch.
 """
 
-version_info = (1, 17, 0)
+version_info = (1, 11, 0)
 
 if __name__ == 'bzrlib.plugins.loggerhead':
     import bzrlib
     from bzrlib.api import require_any_api
 
-    require_any_api(bzrlib, [
-        (1, 13, 0), (1, 15, 0), (1, 16, 0), (1, 17, 0), (1, 18, 0),
-        (2, 0, 0), (2, 1, 0)])
+    require_any_api(bzrlib, [(1, 11, 0), (1, 13, 0), (1, 15, 0)])
+
+    # TODO: This should provide a new type of server that can be used by bzr
+    # serve, maybe through a registry, rather than overriding the command.  Though
+    # maybe we should keep the wrapper to work with older bzr releases, at least
+    # for a bit.
 
     # NB: Normally plugins should lazily load almost everything, but this
     # seems reasonable to have in-line here: bzrlib.commands and options are
     # normally loaded, and the rest of loggerhead won't be loaded until serve
     # --http is run.
-
-    # transport_server_registry was added in bzr 1.16. When we drop support for
-    # older releases, we can remove the code to override cmd_serve.
-
-    try:
-        from bzrlib.transport import transport_server_registry
-    except ImportError:
-        transport_server_registry = None
-
-    DEFAULT_HOST = '0.0.0.0'
+        
+    import bzrlib.builtins
+    from bzrlib.commands import get_cmd_object, register_command
+    from bzrlib.option import Option
+
+    _original_command = get_cmd_object('serve')
+
     DEFAULT_PORT = 8080
-    HELP = ('Loggerhead, a web-based code viewer and server. (default port: %d)' %
-            (DEFAULT_PORT,))
-
-    def serve_http(transport, host=None, port=None, inet=None):
-        from paste.httpexceptions import HTTPExceptionHandler
-        from paste.httpserver import serve
-
-        # loggerhead internal code will try to 'import loggerhead', so
-        # let's put it on the path if we can't find it in the existing path
-        try:
-            import loggerhead
-        except ImportError:
-            import os.path, sys
-            sys.path.append(os.path.dirname(__file__))
-
-        from loggerhead.apps.transport import BranchesFromTransportRoot
-        from loggerhead.config import LoggerheadConfig
-
-        if host is None:
-            host = DEFAULT_HOST
-        if port is None:
-            port = DEFAULT_PORT
-        argv = ['--host', host, '--port', str(port), '--', transport.base]
-        if not transport.is_readonly():
-            argv.insert(0, '--allow-writes')
-        config = LoggerheadConfig(argv)
-        app = BranchesFromTransportRoot(transport.base, config)
-        app = HTTPExceptionHandler(app)
-        serve(app, host=host, port=port)
-
-    if transport_server_registry is not None:
-        transport_server_registry.register('http', serve_http, help=HELP)
-    else:
-        import bzrlib.builtins
-        from bzrlib.commands import get_cmd_object, register_command
-        from bzrlib.option import Option
-
-        _original_command = get_cmd_object('serve')
-
-        class cmd_serve(bzrlib.builtins.cmd_serve):
-            __doc__ = _original_command.__doc__
-
-            takes_options = _original_command.takes_options + [
-                Option('http', help=HELP)]
-
-            def run(self, *args, **kw):
-                if 'http' in kw:
-                    from bzrlib.transport import get_transport
-                    allow_writes = kw.get('allow_writes', False)
-                    path = kw.get('directory', '.')
-                    port = kw.get('port', DEFAULT_PORT)
-                    # port might be an int already...
-                    if isinstance(port, basestring) and ':' in port:
-                        host, port = port.split(':')
-                    else:
-                        host = DEFAULT_HOST
-                    if allow_writes:
-                        transport = get_transport(path)
-                    else:
-                        transport = get_transport('readonly+' + path)
-                    serve_http(transport, host, port)
+
+    class cmd_serve(bzrlib.builtins.cmd_serve):
+        __doc__ = _original_command.__doc__
+
+        takes_options = _original_command.takes_options + [
+            Option('http',
+                help='Run an http (Loggerhead) server to browse code, '
+                    'by default on port %s.' % DEFAULT_PORT)]
+
+        def run(self, *args, **kw):
+            if 'http' in kw:
+                # loggerhead internal code will try to 'import loggerhead', so
+                # let's put it on the path
+                import os.path, sys
+                sys.path.append(os.path.dirname(__file__))
+
+                from bzrlib.transport import get_transport
+                from loggerhead.apps.transport import BranchesFromTransportRoot
+                from loggerhead.config import LoggerheadConfig
+                from paste.httpexceptions import HTTPExceptionHandler
+                from paste.httpserver import serve
+                path = kw.get('directory', '.')
+                port = kw.get('port', DEFAULT_PORT)
+                # port might be an int already...
+                if isinstance(port, basestring) and ':' in port:
+                    host, port = port.split(':')
                 else:
-                    super(cmd_serve, self).run(*args, **kw)
+                    host = '0.0.0.0'
+                argv = ['--host', host, '--port', str(port), path]
+                config = LoggerheadConfig(argv)
+                transport = get_transport(path)
+                app = BranchesFromTransportRoot(transport, config)
+                app = HTTPExceptionHandler(app)
+                serve(app, host=host, port=port)
+            else:
+                super(cmd_serve, self).run(*args, **kw)
 
-        register_command(cmd_serve)
+    register_command(cmd_serve)

=== removed directory 'docs'
=== removed file 'docs/Makefile'
--- docs/Makefile	2010-03-23 15:44:51 +0000
+++ docs/Makefile	1970-01-01 00:00:00 +0000
@@ -1,89 +0,0 @@
-# Makefile for Sphinx documentation
-#
-
-# You can set these variables from the command line.
-SPHINXOPTS    =
-SPHINXBUILD   = sphinx-build
-PAPER         =
-BUILDDIR      = _build
-
-# Internal variables.
-PAPEROPT_a4     = -D latex_paper_size=a4
-PAPEROPT_letter = -D latex_paper_size=letter
-ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
-
-.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest
-
-help:
-	@echo "Please use \`make <target>' where <target> is one of"
-	@echo "  html      to make standalone HTML files"
-	@echo "  dirhtml   to make HTML files named index.html in directories"
-	@echo "  pickle    to make pickle files"
-	@echo "  json      to make JSON files"
-	@echo "  htmlhelp  to make HTML files and a HTML help project"
-	@echo "  qthelp    to make HTML files and a qthelp project"
-	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
-	@echo "  changes   to make an overview of all changed/added/deprecated items"
-	@echo "  linkcheck to check all external links for integrity"
-	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"
-
-clean:
-	-rm -rf $(BUILDDIR)/*
-
-html:
-	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
-	@echo
-	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."
-
-dirhtml:
-	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
-	@echo
-	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."
-
-pickle:
-	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
-	@echo
-	@echo "Build finished; now you can process the pickle files."
-
-json:
-	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
-	@echo
-	@echo "Build finished; now you can process the JSON files."
-
-htmlhelp:
-	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
-	@echo
-	@echo "Build finished; now you can run HTML Help Workshop with the" \
-	      ".hhp project file in $(BUILDDIR)/htmlhelp."
-
-qthelp:
-	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
-	@echo
-	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
-	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
-	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/loggerhead.qhcp"
-	@echo "To view the help file:"
-	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/loggerhead.qhc"
-
-latex:
-	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
-	@echo
-	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
-	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
-	      "run these through (pdf)latex."
-
-changes:
-	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
-	@echo
-	@echo "The overview file is in $(BUILDDIR)/changes."
-
-linkcheck:
-	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
-	@echo
-	@echo "Link check complete; look for any errors in the above output " \
-	      "or in $(BUILDDIR)/linkcheck/output.txt."
-
-doctest:
-	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
-	@echo "Testing of doctests in the sources finished, look at the " \
-	      "results in $(BUILDDIR)/doctest/output.txt."

=== removed directory 'docs/_build'
=== removed directory 'docs/_static'
=== removed directory 'docs/_templates'
=== removed file 'docs/conf.py'
--- docs/conf.py	2010-03-23 15:44:51 +0000
+++ docs/conf.py	1970-01-01 00:00:00 +0000
@@ -1,194 +0,0 @@
-# -*- coding: utf-8 -*-
-#
-# loggerhead documentation build configuration file, created by
-# sphinx-quickstart on Tue Mar 23 10:49:50 2010.
-#
-# This file is execfile()d with the current directory set to its containing dir.
-#
-# Note that not all possible configuration values are present in this
-# autogenerated file.
-#
-# All configuration values have a default; values that are commented out
-# serve to show the default.
-
-import sys, os
-
-# If extensions (or modules to document with autodoc) are in another directory,
-# add these directories to sys.path here. If the directory is relative to the
-# documentation root, use os.path.abspath to make it absolute, like shown here.
-#sys.path.append(os.path.abspath('.'))
-
-# -- General configuration -----------------------------------------------------
-
-# Add any Sphinx extension module names here, as strings. They can be extensions
-# coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = []
-
-# Add any paths that contain templates here, relative to this directory.
-templates_path = ['_templates']
-
-# The suffix of source filenames.
-source_suffix = '.rst'
-
-# The encoding of source files.
-#source_encoding = 'utf-8'
-
-# The master toctree document.
-master_doc = 'index'
-
-# General information about the project.
-project = u'loggerhead'
-copyright = u'2010, Loggerhead team (https://launchpad.net/~loggerhead-team)'
-
-# The version info for the project you're documenting, acts as replacement for
-# |version| and |release|, also used in various other places throughout the
-# built documents.
-#
-# The short X.Y version.
-version = '1.17'
-# The full version, including alpha/beta/rc tags.
-release = '1.17'
-
-# The language for content autogenerated by Sphinx. Refer to documentation
-# for a list of supported languages.
-#language = None
-
-# There are two options for replacing |today|: either, you set today to some
-# non-false value, then it is used:
-#today = ''
-# Else, today_fmt is used as the format for a strftime call.
-#today_fmt = '%B %d, %Y'
-
-# List of documents that shouldn't be included in the build.
-#unused_docs = []
-
-# List of directories, relative to source directory, that shouldn't be searched
-# for source files.
-exclude_trees = ['_build']
-
-# The reST default role (used for this markup: `text`) to use for all documents.
-#default_role = None
-
-# If true, '()' will be appended to :func: etc. cross-reference text.
-#add_function_parentheses = True
-
-# If true, the current module name will be prepended to all description
-# unit titles (such as .. function::).
-#add_module_names = True
-
-# If true, sectionauthor and moduleauthor directives will be shown in the
-# output. They are ignored by default.
-#show_authors = False
-
-# The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
-
-# A list of ignored prefixes for module index sorting.
-#modindex_common_prefix = []
-
-
-# -- Options for HTML output ---------------------------------------------------
-
-# The theme to use for HTML and HTML Help pages.  Major themes that come with
-# Sphinx are currently 'default' and 'sphinxdoc'.
-html_theme = 'default'
-
-# Theme options are theme-specific and customize the look and feel of a theme
-# further.  For a list of options available for each theme, see the
-# documentation.
-#html_theme_options = {}
-
-# Add any paths that contain custom themes here, relative to this directory.
-#html_theme_path = []
-
-# The name for this set of Sphinx documents.  If None, it defaults to
-# "<project> v<release> documentation".
-#html_title = None
-
-# A shorter title for the navigation bar.  Default is the same as html_title.
-#html_short_title = None
-
-# The name of an image file (relative to this directory) to place at the top
-# of the sidebar.
-#html_logo = None
-
-# The name of an image file (within the static path) to use as favicon of the
-# docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
-# pixels large.
-#html_favicon = None
-
-# Add any paths that contain custom static files (such as style sheets) here,
-# relative to this directory. They are copied after the builtin static files,
-# so a file named "default.css" will overwrite the builtin "default.css".
-html_static_path = ['_static']
-
-# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
-# using the given strftime format.
-#html_last_updated_fmt = '%b %d, %Y'
-
-# If true, SmartyPants will be used to convert quotes and dashes to
-# typographically correct entities.
-#html_use_smartypants = True
-
-# Custom sidebar templates, maps document names to template names.
-#html_sidebars = {}
-
-# Additional templates that should be rendered to pages, maps page names to
-# template names.
-#html_additional_pages = {}
-
-# If false, no module index is generated.
-#html_use_modindex = True
-
-# If false, no index is generated.
-#html_use_index = True
-
-# If true, the index is split into individual pages for each letter.
-#html_split_index = False
-
-# If true, links to the reST sources are added to the pages.
-#html_show_sourcelink = True
-
-# If true, an OpenSearch description file will be output, and all pages will
-# contain a <link> tag referring to it.  The value of this option must be the
-# base URL from which the finished HTML is served.
-#html_use_opensearch = ''
-
-# If nonempty, this is the file name suffix for HTML files (e.g. ".xhtml").
-#html_file_suffix = ''
-
-# Output file base name for HTML help builder.
-htmlhelp_basename = 'loggerheaddoc'
-
-
-# -- Options for LaTeX output --------------------------------------------------
-
-# The paper size ('letter' or 'a4').
-#latex_paper_size = 'letter'
-
-# The font size ('10pt', '11pt' or '12pt').
-#latex_font_size = '10pt'
-
-# Grouping the document tree into LaTeX files. List of tuples
-# (source start file, target name, title, author, documentclass [howto/manual]).
-latex_documents = [
-  ('index', 'loggerhead.tex', u'loggerhead Documentation',
-   u'Loggerhead team (https://launchpad.net/\\textasciitilde{}loggerhead-team)', 'manual'),
-]
-
-# The name of an image file (relative to this directory) to place at the top of
-# the title page.
-#latex_logo = None
-
-# For "manual" documents, if this is true, then toplevel headings are parts,
-# not chapters.
-#latex_use_parts = False
-
-# Additional stuff for the LaTeX preamble.
-#latex_preamble = ''
-
-# Documents to append as an appendix to all manuals.
-#latex_appendices = []
-
-# If false, no module index is generated.
-#latex_use_modindex = True

=== removed file 'docs/index.rst'
--- docs/index.rst	2010-03-23 20:10:58 +0000
+++ docs/index.rst	1970-01-01 00:00:00 +0000
@@ -1,215 +0,0 @@
-loggerhead:  A web viewer for ``bzr`` branches
-==============================================
-
-Loggerhead is a web viewer for projects in bazaar. It can be used to navigate 
-a branch history, annotate files, view patches, perform searches, etc.
-oggerhead is heavily based on `bazaar-webserve
-<https://launchpad.net/bzr-webserve>`_, which was, in turn, loosely
-based on `hgweb <http://mercurial.selenic.com/wiki/HgWebDirStepByStep>`_.
-
-
-Getting Started
----------------
-
-Loggerhead depends on the following Python libraries.:
-
-- SimpleTAL for templating.
-
-- simplejson for producing JSON data.
-
-- Paste for the server. (You need version 1.2 or newer of Paste.)
-
-- Paste Deploy  (optional, needed when proxying through Apache)
-
-- flup (optional, needed to use FastCGI, SCGI or AJP)
-
-
-Installing Dependencies Using Ubuntu Packages
-#############################################
-
-.. code-block:: sh
-
-   $ sudo apt-get install python-simpletal
-   $ sudo apt-get install python-simplejson
-   $ sudo apt-get install python-paste
-   $ sudo apt-get install python-pastedeploy
-   $ sudo apt-get install python-flup
-
-Installing Dependencies Using :command:`easy_install`
-#####################################################
-
-.. code-block:: sh
-
-   $ easy_install \
-     -f http://www.owlfish.com/software/simpleTAL/py2compatible/download.html \
-     SimpleTAL
-   $ easy_install simplejson
-   $ easy_install Paste
-   $ easy_install PasteDeploy
-   $ easy_install flup
-
-
-Running the Standalone Loggerhead Server
-----------------------------------------
-
-After installing all the dependencies, you should be able to run
-:command:`serve-branches` with the branch you want to serve on the
-command line:
-
-.. code-block:: sh
-
-    ./serve-branches ~/path/to/branch
-
-By default, the script listens on port 8080, so head to
-http://localhost:8080/ in your browser to see the branch.
-
-You can also pass a directory that contains branches to the script,
-and it will serve a very simple directory listing at other pages.
-
-You may update the Bazaar branches being viewed at any time.
-Loggerhead will notice and refresh, and Bazaar uses its own branch
-locking to prevent corruption.
-
-See :doc:`serve-branches` for all command line options.
-
-Running Loggerhead as a Daemon
-------------------------------
-
-To run loggerhead as a linux daemon:
-
-1) Copy the ``loggerheadd`` scipt to ``/etc/init.d``
-
-.. code-block:: sh
-
-   $ sudo cp ./loggerheadd /etc/init.d
-
-2) Edit the file to configure where your loggerhead is installed, and which
-   serve-branches options you would like.
-
-.. code-block:: sh
-
-   $ sudo vim /etc/init.d/loggerheadd
-
-3) Register the service
-
-a) on upstart based systems like Ubuntu run: 
-
-.. code-block:: sh
-
-   $ sudo update-rc.d loggerheadd defaults
-
-b) on Sysvinit based systems like Centos or SuSE run:
-
-.. code-block:: sh
-
-   $ sudo chkconfig --add loggerheadd
-
-
-Using Loggerhead as a Bazaar Plugin
-------------------------------------
-
-This branch contains experimental support for using Loggerhead as a Bazaar
-plugin.  To use it, place the top-level Loggerhead directory (the one
-containing this file) at ``~/.bazaar/plugins/loggerhead``.  E.g.:
-
-.. code-block:: sh
-
-   $ bzr branch lp:loggerhead ~/.bazaar/plugins/loggerhead
-   $ cd ~/myproject
-   $ bzr serve --http
-
-
-Using a Config File
--------------------
-
-To hide branches from being displayed, add to ``~/.bazaar/locations.conf``,
-under the branch's section:
-
-.. code-block:: ini
-
-    [/path/to/branch]
-    http_serve = False
-
-More configuration options to come soon.
-
-
-Serving Loggerhead from Behind Apache
--------------------------------------
-
-If you want to view Bazaar branches from your existing Apache
-installation, you'll need to configure Apache to proxy certain
-requests to Loggerhead.  Adding lines like this to you Apache
-configuration is one way to do this:
-
-.. code-block:: apache
-
-    <Location "/branches/">
-        ProxyPass http://127.0.0.1:8080/branches/
-        ProxyPassReverse http://127.0.0.1:8080/branches/
-    </Location>
-
-If Paste Deploy is installed, the :command:`serve-branches` script can be
-run behind a proxy at the root of a site, but if you're running it at
-some path into the site, you'll need to specify is using
-``--prefix=/some_path``.
-
-
-Search
-------
-
-Search is currently supported by using the bzr-search plugin (available
-at: https://launchpad.net/bzr-search ).
-
-You need to have the plugin installed and each branch indexed to allow
-searching on branches.
-
-Command-Line Reference
-----------------------
-
-.. toctree::
-   :maxdepth: 2
-
-   serve-branches
-   start-loggerhead
-   stop-loggerhead
-
-
-Support
--------
-
-Discussion should take place on the bazaar-dev mailing list at
-mailto:bazaar@lists.canonical.com.  You can join the list at
-<https://lists.ubuntu.com/mailman/listinfo/bazaar>.  You don't need to
-subscribe to post, but your first post will be held briefly for manual
-moderation.
-
-Bugs are tracked on Launchpad; start at:
-
-    https://bugs.launchpad.net/loggerhead
-
-
-Hacking
--------
-
-To run loggerhead tests, you will need to install the package ``python-nose``,
-and run its :command:`nosetests` script in the loggerhead directory:
-
-.. code-block:: sh
-
-    nosetests
-
-
-License
--------
-
-GNU GPLv2 or later.
-
-See Also
---------
-
-https://launchpad.net/loggerhead
-
-Index
-=====
-
-- :ref:`genindex`

=== removed file 'docs/make.bat'
--- docs/make.bat	2010-03-23 15:44:51 +0000
+++ docs/make.bat	1970-01-01 00:00:00 +0000
@@ -1,113 +0,0 @@
-@ECHO OFF
-
-REM Command file for Sphinx documentation
-
-set SPHINXBUILD=sphinx-build
-set BUILDDIR=_build
-set ALLSPHINXOPTS=-d %BUILDDIR%/doctrees %SPHINXOPTS% .
-if NOT "%PAPER%" == "" (
-	set ALLSPHINXOPTS=-D latex_paper_size=%PAPER% %ALLSPHINXOPTS%
-)
-
-if "%1" == "" goto help
-
-if "%1" == "help" (
-	:help
-	echo.Please use `make ^<target^>` where ^<target^> is one of
-	echo.  html      to make standalone HTML files
-	echo.  dirhtml   to make HTML files named index.html in directories
-	echo.  pickle    to make pickle files
-	echo.  json      to make JSON files
-	echo.  htmlhelp  to make HTML files and a HTML help project
-	echo.  qthelp    to make HTML files and a qthelp project
-	echo.  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter
-	echo.  changes   to make an overview over all changed/added/deprecated items
-	echo.  linkcheck to check all external links for integrity
-	echo.  doctest   to run all doctests embedded in the documentation if enabled
-	goto end
-)
-
-if "%1" == "clean" (
-	for /d %%i in (%BUILDDIR%\*) do rmdir /q /s %%i
-	del /q /s %BUILDDIR%\*
-	goto end
-)
-
-if "%1" == "html" (
-	%SPHINXBUILD% -b html %ALLSPHINXOPTS% %BUILDDIR%/html
-	echo.
-	echo.Build finished. The HTML pages are in %BUILDDIR%/html.
-	goto end
-)
-
-if "%1" == "dirhtml" (
-	%SPHINXBUILD% -b dirhtml %ALLSPHINXOPTS% %BUILDDIR%/dirhtml
-	echo.
-	echo.Build finished. The HTML pages are in %BUILDDIR%/dirhtml.
-	goto end
-)
-
-if "%1" == "pickle" (
-	%SPHINXBUILD% -b pickle %ALLSPHINXOPTS% %BUILDDIR%/pickle
-	echo.
-	echo.Build finished; now you can process the pickle files.
-	goto end
-)
-
-if "%1" == "json" (
-	%SPHINXBUILD% -b json %ALLSPHINXOPTS% %BUILDDIR%/json
-	echo.
-	echo.Build finished; now you can process the JSON files.
-	goto end
-)
-
-if "%1" == "htmlhelp" (
-	%SPHINXBUILD% -b htmlhelp %ALLSPHINXOPTS% %BUILDDIR%/htmlhelp
-	echo.
-	echo.Build finished; now you can run HTML Help Workshop with the ^
-.hhp project file in %BUILDDIR%/htmlhelp.
-	goto end
-)
-
-if "%1" == "qthelp" (
-	%SPHINXBUILD% -b qthelp %ALLSPHINXOPTS% %BUILDDIR%/qthelp
-	echo.
-	echo.Build finished; now you can run "qcollectiongenerator" with the ^
-.qhcp project file in %BUILDDIR%/qthelp, like this:
-	echo.^> qcollectiongenerator %BUILDDIR%\qthelp\loggerhead.qhcp
-	echo.To view the help file:
-	echo.^> assistant -collectionFile %BUILDDIR%\qthelp\loggerhead.ghc
-	goto end
-)
-
-if "%1" == "latex" (
-	%SPHINXBUILD% -b latex %ALLSPHINXOPTS% %BUILDDIR%/latex
-	echo.
-	echo.Build finished; the LaTeX files are in %BUILDDIR%/latex.
-	goto end
-)
-
-if "%1" == "changes" (
-	%SPHINXBUILD% -b changes %ALLSPHINXOPTS% %BUILDDIR%/changes
-	echo.
-	echo.The overview file is in %BUILDDIR%/changes.
-	goto end
-)
-
-if "%1" == "linkcheck" (
-	%SPHINXBUILD% -b linkcheck %ALLSPHINXOPTS% %BUILDDIR%/linkcheck
-	echo.
-	echo.Link check complete; look for any errors in the above output ^
-or in %BUILDDIR%/linkcheck/output.txt.
-	goto end
-)
-
-if "%1" == "doctest" (
-	%SPHINXBUILD% -b doctest %ALLSPHINXOPTS% %BUILDDIR%/doctest
-	echo.
-	echo.Testing of doctests in the sources finished, look at the ^
-results in %BUILDDIR%/doctest/output.txt.
-	goto end
-)
-
-:end

=== removed file 'docs/serve-branches.rst'
--- docs/serve-branches.rst	2010-03-23 19:54:47 +0000
+++ docs/serve-branches.rst	1970-01-01 00:00:00 +0000
@@ -1,115 +0,0 @@
-:command:`serve-branches`
-=========================
-
-The :command:`serve-branches` script runs a standalone loggerhead server in
-the foreground.
-
-.. program:: serve-branches
-
-Usage
------
-
-.. code-block:: sh
-
-   serve-branches [OPTIONS] <target directory>
-
-Options
--------
-
-.. cmdoption:: --user-dirs
-
-    Serve user directories as ``~user`` (requires ``--trunk-dir``).
-
-    If both options are set, then for requests where the CGI ``PATH_INFO``
-    starts with "/~<name>", serve branches under the <name> directory.
-
-.. cmdoption:: --trunk-dir=DIR
-
-    The directory that contains the trunk branches (requires ``--user-dirs``).
-
-    If both options are set, then for requests where the CGI ``PATH_INFO``
-    does not start with "/~<name>", serve branches under DIR.
-
-.. cmdoption:: --port
-
-    Listen on the given port.
-    
-    Defaults to 8080.
-
-.. cmdoption:: --host
-
-    Listen on the interface corresponding to the given IP. 
-    
-    Defaults to listening on all interfaces, i.e., "0.0.0.0".
-
-.. cmdoption:: --protocol
-
-    Serve the application using the specified protocol.
-    
-    Can be one of: "http", "scgi", "fcgi", "ajp" (defaults to "http").
-
-.. cmdoption:: --prefix
-
-    Set the supplied value as the CGI ``SCRIPT_NAME`` for the application.
-
-    This option is intended for use when serving Loggerhead behind a
-    reverse proxy, with Loggerhead being "mounted" at a directory below
-    the root.  E.g., if the reverse proxy translates requests for
-    ``http://example.com/loggerhead`` onto the standalone Loggerhead process,
-    that process should be run with ``--prefix=/loggerhead``.
-
-.. cmdoption:: --log-folder=LOG_FOLDER
-
-    The directory in which to place loggerhead's log files.
-    
-    Defaults to the current directory.
-
-.. cmdoption:: --cache-dir=SQL_CACHE_DIR
-
-    The directory in which to place the SQL cache.
-
-    Defaults to the current directory.
-
-.. cmdoption:: --use-cdn
-   
-    Serve YUI javascript libraries from Yahoo!'s CDN.
-
-.. cmdoption:: --allow-writes
-   
-    Allow writing to the Bazaar server.
-    
-    Setting this option keeps loggerhead from adding a 'readonly+' prefix
-    to the base URL of is to make visible the display of instructions for
-    checking out the 'public_branch' URL for the branch being browsed.
-
-.. cmdoption:: -h, --help
-
-    Print the help message and exit
-
-.. cmdoption:: --version
-
-    Print the software version and exit.
-
-Debugging Options
------------------
-
-The following options are only useful when developing / debugging Loggerhead
-itself.
-
-.. cmdoption:: --profile
-   
-    Generate per-request callgrind profile data.
-    
-    Data for each request is written to a file ``%d-stats.callgrind``,
-    where ``%d`` is replaced by the sequence number of the request.
-
-.. cmdoption:: --memory-profile
-
-    Profile the memory usage using the `Dozer
-    <http://pypi.python.org/pypi/Dozer>`_ middleware.
-
-.. cmdoption:: --reload
-
-    Restart the application when any of its python file change.
-    
-    This option should only used for development purposes.

=== removed file 'docs/start-loggerhead.rst'
--- docs/start-loggerhead.rst	2010-03-23 19:54:47 +0000
+++ docs/start-loggerhead.rst	1970-01-01 00:00:00 +0000
@@ -1,46 +0,0 @@
-:command:`start-loggerhead`
-===========================
-
-The :command:`start-loggerhead` command starts a new standalone loggerhead
-server.  By default, the server runs in the background (daemonized).
-
-.. program:: start-loggerhead
-
-Usage
------
-
-.. code-block:: sh
-
-   start-loggerhead [OPTIONS]
-
-Options
--------
-
-.. cmdoption:: --version
-
-    Print the software version and exit.
-
-.. cmdoption:: -h, --help
-
-    Show this help message and exit
-
-.. cmdoption:: --foreground
-
-    Run in the foreground;  don't daemonize.
-
-.. cmdoption:: -C, --check
-
-    Only start if not already running (useful for cron jobs)
-
-.. cmdoption:: -p, --pidfile=PIDFILE
-
-    override pid file location
-
-.. cmdoption:: -c, --config-file=CONFIGFILE
-
-   Override configuration file location [XXX default is
-   :file:`/etc/loggerhead.conf`]
-
-.. cmdoption:: --log-folder=LOG_FOLDER
-
-    The directory [XXX in which] to place log files

=== removed file 'docs/stop-loggerhead.rst'
--- docs/stop-loggerhead.rst	2010-03-23 19:54:47 +0000
+++ docs/stop-loggerhead.rst	1970-01-01 00:00:00 +0000
@@ -1,18 +0,0 @@
-:command:`stop-loggerhead`
-======================================================================
-
-The :command:`stop-loggerhead` command stops the currently running loggerhead
-daemon.
-
-.. program:: stop-loggerhead
-
-Usage
------
-
-.. code-block:: sh
-
-   stop-loggerhead [OPTIONS]
-
-.. cmdoption:: -p, --pidfile=PIDFILE
-
-   override pid file location

=== modified file 'loggerhead/__init__.py'
--- loggerhead/__init__.py	2009-08-20 13:30:37 +0000
+++ loggerhead/__init__.py	2009-02-10 21:11:43 +0000
@@ -1,6 +1,3 @@
-#
-# Copyright (C) 2008, 2009 Canonical Ltd.
-#
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
@@ -22,8 +19,8 @@
 
 import pkg_resources
 
-__version__ = '1.17'
-required_bzrlib = (1, 17)
+__version__ = '1.10'
+required_bzrlib = (1, 6)
 
 pkg_resources.get_distribution('Paste>=1.6')
 try:

=== modified file 'loggerhead/apps/__init__.py'
--- loggerhead/apps/__init__.py	2009-11-26 03:44:40 +0000
+++ loggerhead/apps/__init__.py	2009-02-19 01:24:20 +0000
@@ -4,15 +4,10 @@
 
 from paste import urlparser, fileapp
 
-from loggerhead.util import convert_file_errors
-
 static = os.path.join(
     os.path.dirname(os.path.dirname(__file__)), 'static')
 
 static_app = urlparser.make_static(None, static)
 
-favicon_app = convert_file_errors(fileapp.FileApp(
-    os.path.join(static, 'images', 'favicon.ico')))
-
-robots_app = convert_file_errors(fileapp.FileApp(
-    os.path.join(static, 'robots.txt')))
+favicon_app = fileapp.FileApp(os.path.join(static, 'images', 'favicon.ico'))
+robots_app = fileapp.FileApp(os.path.join(static, 'robots.txt'))

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2009-10-17 06:35:33 +0000
+++ loggerhead/apps/branch.py	2009-05-27 09:55:41 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd.
+# Copyright (C) 2008, 2009  Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -52,7 +52,7 @@
         self._config = config
         self.friendly_name = friendly_name
         self.branch_link = branch_link  # Currently only used in Launchpad
-        self.log = logging.getLogger('loggerhead.%s' % (friendly_name,))
+        self.log = logging.getLogger('loggerhead.%s' % friendly_name)
         if graph_cache is None:
             graph_cache = bzrlib.lru_cache.LRUCache(10)
         self.graph_cache = graph_cache
@@ -86,7 +86,7 @@
         qs = []
         for k, v in kw.iteritems():
             if v is not None:
-                qs.append('%s=%s' % (k, urllib.quote(v)))
+                qs.append('%s=%s'%(k, urllib.quote(v)))
         qs = '&'.join(qs)
         return request.construct_url(
             self._environ, script_name=self._url_base,
@@ -143,12 +143,7 @@
             if public_branch is not None:
                 self.served_url = public_branch
             else:
-                # Loggerhead only supports serving .bzr/ on local branches, so
-                # we shouldn't suggest something that won't work.
-                if self.branch.base.startswith('file://'):
-                    self.served_url = self.url([])
-                else:
-                    self.served_url = None
+                self.served_url = self.url([])
         path = request.path_info_pop(environ)
         if not path:
             raise httpexceptions.HTTPMovedPermanently(

=== modified file 'loggerhead/apps/error.py'
--- loggerhead/apps/error.py	2009-10-17 08:47:38 +0000
+++ loggerhead/apps/error.py	2008-10-24 02:26:05 +0000
@@ -53,6 +53,6 @@
 
 
 def errapp(environ, start_response):
-    """Default (and trivial) error handling WSGI application."""
+    '''Default (and trivial) error handling WSGI application.'''
     c = ErrorUI(environ['branch'], environ['exc_info'])
     return c(environ, start_response)

=== modified file 'loggerhead/apps/transport.py'
--- loggerhead/apps/transport.py	2009-11-26 03:20:53 +0000
+++ loggerhead/apps/transport.py	2009-05-27 09:55:41 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd.
+# Copyright (C) 2008, 2009  Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,28 +16,18 @@
 #
 """Serve branches at urls that mimic a transport's file system layout."""
 
-import threading
-
 from bzrlib import branch, errors, lru_cache, urlutils
-from bzrlib.config import LocationConfig
-from bzrlib.smart import request
-from bzrlib.transport import get_transport
-from bzrlib.transport.http import wsgi
+from bzrlib.bzrdir import BzrDir
 
 from paste.request import path_info_pop
 from paste import httpexceptions
 from paste import urlparser
 
 from loggerhead.apps.branch import BranchWSGIApp
-from loggerhead.apps import favicon_app, robots_app, static_app
+from loggerhead.apps import favicon_app, static_app
+from loggerhead.config import LoggerheadConfig
 from loggerhead.controllers.directory_ui import DirectoryUI
 
-_bools = {
-    'yes': True, 'no': False,
-    'on': True, 'off': False,
-    '1': True, '0': False,
-    'true': True, 'false': False,
-    }
 
 class BranchesFromTransportServer(object):
 
@@ -55,13 +45,10 @@
             name = self.name
             is_root = False
         branch_app = BranchWSGIApp(
-            branch,
-            name,
+            branch, name,
             {'cachepath': self._config.SQL_DIR},
-            self.root.graph_cache,
-            is_root=is_root,
-            use_cdn=self._config.get_option('use_cdn'),
-            )
+            self.root.graph_cache, is_root=is_root,
+            use_cdn=self._config.get_option('use_cdn'))
         return branch_app.app
 
     def app_for_non_branch(self, environ):
@@ -74,8 +61,9 @@
                 name = self.name
             else:
                 name = '/'
-            return DirectoryUI(
-                environ['loggerhead.static.url'], self.transport, name)
+            return DirectoryUI(environ['loggerhead.static.url'],
+                               self.transport,
+                               name)
         else:
             new_transport = self.transport.clone(segment)
             if self.name:
@@ -84,99 +72,61 @@
                 new_name = '/' + segment
             return BranchesFromTransportServer(new_transport, self.root, new_name)
 
-    def app_for_bazaar_data(self, relpath):
-        if relpath == '/.bzr/smart':
-            root_transport = get_transport_for_thread(self.root.base)
-            wsgi_app = wsgi.SmartWSGIApp(root_transport)
-            return wsgi.RelpathSetter(wsgi_app, '', 'loggerhead.path_info')
-        else:
-            # TODO: Use something here that uses the transport API
-            # rather than relying on the local filesystem API.
-            base = self.transport.base
-            readonly_prefix = 'readonly+'
-            if base.startswith(readonly_prefix):
-                base = base[len(readonly_prefix):]
-            try:
-                path = urlutils.local_path_from_url(base)
-            except errors.InvalidURL:
-                raise httpexceptions.HTTPNotFound()
-            else:
-                return urlparser.make_static(None, path)
-
-    def check_serveable(self, config):
-        value = config.get_user_option('http_serve')
-        if value is None:
-            return
-        elif not _bools.get(value.lower(), True):
-            raise httpexceptions.HTTPNotFound()
-
     def __call__(self, environ, start_response):
-        path = environ['PATH_INFO']
         try:
             b = branch.Branch.open_from_transport(self.transport)
         except errors.NotBranchError:
-            if path.startswith('/.bzr'):
-                self.check_serveable(LocationConfig(self.transport.base))
-                return self.app_for_bazaar_data(path)(environ, start_response)
             if not self.transport.listable() or not self.transport.has('.'):
                 raise httpexceptions.HTTPNotFound()
             return self.app_for_non_branch(environ)(environ, start_response)
         else:
-            self.check_serveable(b.get_config())
-            if path.startswith('/.bzr'):
-                return self.app_for_bazaar_data(path)(environ, start_response)
+            if b.get_config().get_user_option('http_serve') == 'False':
+                raise httpexceptions.HTTPNotFound()
             else:
                 return self.app_for_branch(b)(environ, start_response)
 
 
-_transport_store = threading.local()
-
-def get_transport_for_thread(base):
-    thread_transports = getattr(_transport_store, 'transports', None)
-    if thread_transports is None:
-        thread_transports = _transport_store.transports = {}
-    if base in thread_transports:
-        return thread_transports[base]
-    transport = get_transport(base)
-    thread_transports[base] = transport
-    return transport
-
-
 class BranchesFromTransportRoot(object):
 
-    def __init__(self, base, config):
+    def __init__(self, transport, config):
         self.graph_cache = lru_cache.LRUCache(10)
-        self.base = base
+        self.transport = transport
         self._config = config
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
-        environ['loggerhead.path_info'] = environ['PATH_INFO']
         if environ['PATH_INFO'].startswith('/static/'):
             segment = path_info_pop(environ)
             assert segment == 'static'
             return static_app(environ, start_response)
         elif environ['PATH_INFO'] == '/favicon.ico':
             return favicon_app(environ, start_response)
-        elif environ['PATH_INFO'] == '/robots.txt':
-            return robots_app(environ, start_response)
+        elif '/.bzr/' in environ['PATH_INFO']:
+            try:
+                bzrdir = BzrDir.open_containing_from_transport(
+                         self.transport.clone(environ['PATH_INFO']))
+                branch = bzrdir.open_branch()
+                if branch.get_config().get_user_option('http_serve') == 'False':
+                    raise httpexceptions.HTTPNotFound()
+            except errors.NotBranchError:
+                pass
+            app = urlparser.make_static(None, self.transport)
+            return app(environ, start_response)
         else:
-            transport = get_transport_for_thread(self.base)
             return BranchesFromTransportServer(
-                transport, self)(environ, start_response)
+                self.transport, self)(environ, start_response)
 
 
 class UserBranchesFromTransportRoot(object):
 
-    def __init__(self, base, config):
+    def __init__(self, transport, config):
         self.graph_cache = lru_cache.LRUCache(10)
-        self.base = base
+        self.transport = transport
         self._config = config
         self.trunk_dir = config.get_option('trunk_dir')
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
-        environ['loggerhead.path_info'] = environ['PATH_INFO']
         path_info = environ['PATH_INFO']
         if path_info.startswith('/static/'):
             segment = path_info_pop(environ)
@@ -184,17 +134,14 @@
             return static_app(environ, start_response)
         elif path_info == '/favicon.ico':
             return favicon_app(environ, start_response)
-        elif environ['PATH_INFO'] == '/robots.txt':
-            return robots_app(environ, start_response)
         else:
-            transport = get_transport_for_thread(self.base)
             # segments starting with ~ are user branches
             if path_info.startswith('/~'):
                 segment = path_info_pop(environ)
+                new_transport = self.transport.clone(segment[1:])
                 return BranchesFromTransportServer(
-                    transport.clone(segment[1:]), self, segment)(
-                    environ, start_response)
+                    new_transport, self, segment)(environ, start_response)
             else:
+                new_transport = self.transport.clone(self.trunk_dir)
                 return BranchesFromTransportServer(
-                    transport.clone(self.trunk_dir), self)(
-                    environ, start_response)
+                    new_transport, self)(environ, start_response)

=== modified file 'loggerhead/config.py'
--- loggerhead/config.py	2009-11-23 22:45:46 +0000
+++ loggerhead/config.py	2009-05-18 05:16:38 +0000
@@ -1,23 +1,8 @@
-#
-# Copyright (C) 2008, 2009 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-"""Configuration tools for Loggerhead."""
-
+'''Configuration tools for Loggerhead.'''
 from optparse import OptionParser
 import sys
 import tempfile
 
-from bzrlib import config
 
 _temporary_sql_dir = None
 
@@ -35,9 +20,8 @@
         log_folder=None,
         use_cdn=False,
         sql_dir=None,
-        allow_writes=False,
         )
-    parser.add_option("--user-dirs", action="store_true",
+    parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
                       help="Serve user directories as ~user.")
     parser.add_option("--trunk-dir", metavar="DIR",
                       help="The directory that contains the trunk branches.")
@@ -46,34 +30,30 @@
                             "(defaults to 8080)."))
     parser.add_option("--host", dest="user_host",
                       help="Host Loggerhead should listen on.")
-    parser.add_option("--protocol", dest="protocol",
-                      help=("Protocol to use: http, scgi, fcgi, ajp"
-                           "(defaults to http)."))
-    parser.add_option("--memory-profile", action="store_true",
-                      help="Profile the memory usage using Dozer.")
+    parser.add_option('--memory-profile', action='store_true',
+                      dest='memory_profile',
+                      help='Profile the memory usage using heapy.')
     parser.add_option("--prefix", dest="user_prefix",
                       help="Specify host prefix.")
-    parser.add_option("--profile", action="store_true",
+    parser.add_option("--profile", action="store_true", dest="profile",
                       help="Generate callgrind profile data to "
                         "%d-stats.callgrind on each request.")
-    parser.add_option("--reload", action="store_true",
+    parser.add_option("--reload", action="store_true", dest="reload",
                       help="Restarts the application when changing python"
                            " files. Only used for development purposes.")
-    parser.add_option("--log-folder",
-                      help="The directory to place log files in.")
+    parser.add_option('--log-folder', dest="log_folder",
+                      type=str, help="The directory to place log files in.")
     parser.add_option("--version", action="store_true", dest="show_version",
                       help="Print the software version and exit")
-    parser.add_option("--use-cdn", action="store_true", dest="use_cdn",
+    parser.add_option('--use-cdn', action='store_true',
                       help="Serve YUI from Yahoo!'s CDN")
-    parser.add_option("--cache-dir", dest="sql_dir",
+    parser.add_option('--cache-dir', dest='sql_dir',
                       help="The directory to place the SQL cache in")
-    parser.add_option("--allow-writes", action="store_true",
-                      help="Allow writing to the Bazaar server.")
     return parser
 
 
 class LoggerheadConfig(object):
-    """A configuration object."""
+    '''A configuration object.'''
 
     def __init__(self, argv=None):
         if argv is None:
@@ -87,27 +67,19 @@
         self.SQL_DIR = sql_dir
 
     def get_option(self, option):
-        """Get the value for the config option, either 
-        from ~/.bazaar/bazaar.conf or from the command line.
-        All loggerhead-specific settings start with 'http_'
-        """
-        global_config = config.GlobalConfig().get_user_option('http_'+option)
-        cmd_config = getattr(self._options, option)
-        if global_config is not None and (
-            cmd_config is None or cmd_config is False):
-            return global_config
-        else:
-            return cmd_config
+        '''Get an option from the options dict.'''
+        return getattr(self._options, option)
 
     def get_arg(self, index):
-        """Get an arg from the arg list."""
+        '''Get an arg from the arg list.'''
         return self._args[index]
 
     def print_help(self):
-        """Wrapper around OptionParser.print_help."""
+        '''Wrapper around OptionParser.print_help.'''
         return self._parser.print_help()
 
     @property
     def arg_count(self):
-        """Return the number of args from the option parser."""
+        '''Return the number of args from the option parser.'''
         return len(self._args)
+

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2009-10-17 08:59:33 +0000
+++ loggerhead/controllers/__init__.py	2009-03-02 05:44:20 +0000
@@ -70,7 +70,7 @@
         kwargs = dict(parse_querystring(environ))
         util.set_context(kwargs)
         args = []
-        while True:
+        while 1:
             arg = path_info_pop(environ)
             if arg is None:
                 break

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2009-10-17 06:35:33 +0000
+++ loggerhead/controllers/annotate_ui.py	2009-05-16 06:05:56 +0000
@@ -62,10 +62,10 @@
         try:
             bzrlib.textfile.check_text_lines(file_lines)
         except bzrlib.errors.BinaryFile:
-            # bail out; this isn't displayable text
-            yield util.Container(parity=0, lineno=1, status='same',
-                                 text='(This is a binary file.)',
-                                 change=util.Container())
+                # bail out; this isn't displayable text
+                yield util.Container(parity=0, lineno=1, status='same',
+                                     text='(This is a binary file.)',
+                                     change=util.Container())
         else:
             if highlight is not None:
                 hl_lines = highlight(file_name, file_text, encoding)
@@ -95,7 +95,7 @@
                     change=change, text=hl_lines[lineno - 1])
                 lineno += 1
 
-        self.log.debug('annotate: %r secs' % (time.time() - z,))
+        self.log.debug('annotate: %r secs' % (time.time() - z))
 
     def get_values(self, path, kwargs, headers):
         history = self._history

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2009-07-07 23:52:24 +0000
+++ loggerhead/controllers/atom_ui.py	2008-12-05 18:52:44 +0000
@@ -26,6 +26,7 @@
 
     def get_values(self, path, kwargs, headers):
         history = self._history
+        revid = self.get_revid()
         pagesize = int(20)#self._branch.config.get('pagesize', '20'))
 
         revid_list = history.get_file_view(history.last_revid, None)
@@ -34,6 +35,6 @@
         headers['Content-Type'] = 'application/atom+xml'
         return {
             'changes': entries,
-            'updated': entries[0].utc_date.isoformat(),
+            'updated': entries[0].date.isoformat() + 'Z',
             'history': self._history,
         }

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2009-06-25 03:35:43 +0000
+++ loggerhead/controllers/changelog_ui.py	2009-03-17 22:38:57 +0000
@@ -1,5 +1,4 @@
 #
-# Copyright (C) 2008, 2009 Canonical Ltd.
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
 # Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
 #
@@ -89,16 +88,9 @@
                 self._branch.is_root,
                 'changes'))
 
-        show_tag_col = False
-        for change in changes:
-            if change.tags is not None:
-                show_tag_col = True
-                break
-
         return {
             'branch': self._branch,
             'changes': changes,
-            'show_tag_col': show_tag_col,
             'data': simplejson.dumps(data),
             'util': util,
             'history': history,

=== modified file 'loggerhead/controllers/diff_ui.py'
--- loggerhead/controllers/diff_ui.py	2009-10-17 08:59:33 +0000
+++ loggerhead/controllers/diff_ui.py	2008-12-05 18:52:44 +0000
@@ -38,7 +38,7 @@
         z = time.time()
 
         args = []
-        while True:
+        while 1:
             arg = path_info_pop(environ)
             if arg is None:
                 break
@@ -73,7 +73,7 @@
         headers = [
             ('Content-Type', 'application/octet-stream'),
             ('Content-Length', len(content)),
-            ('Content-Disposition', 'attachment; filename=%s' % (filename,)),
+            ('Content-Disposition', 'attachment; filename=%s' % filename),
             ]
         start_response('200 OK', headers)
         return [content]

=== modified file 'loggerhead/controllers/directory_ui.py'
--- loggerhead/controllers/directory_ui.py	2009-10-17 06:35:33 +0000
+++ loggerhead/controllers/directory_ui.py	2009-05-26 16:21:53 +0000
@@ -20,7 +20,7 @@
 import logging
 import stat
 
-from bzrlib import branch, errors
+from bzrlib import branch
 
 from loggerhead import util
 from loggerhead.controllers import TemplatedBranchView
@@ -57,7 +57,7 @@
             def static_url(path):
                 return self._static_url_base + path
         self._branch = _branch
-        self._history_callable = lambda: None
+        self._history_callable = lambda:None
         self._name = name
         self._static_url_base = static_url_base
         self.transport = transport
@@ -72,13 +72,10 @@
         for d in listing:
             try:
                 b = branch.Branch.open_from_transport(self.transport.clone(d))
-                if b.get_config().get_user_option('http_serve') == 'False':
+            	if b.get_config().get_user_option('http_serve') == 'False':
                     continue
             except:
-                try:
-                    if not stat.S_ISDIR(self.transport.stat(d).st_mode):
-                        continue
-                except errors.NoSuchFile:
+                if not stat.S_ISDIR(self.transport.stat(d).st_mode):
                     continue
                 b = None
             dirs.append(DirEntry(d, parity, b))

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2009-10-17 09:21:55 +0000
+++ loggerhead/controllers/download_ui.py	2009-02-06 05:53:36 +0000
@@ -19,6 +19,7 @@
 
 import logging
 import mimetypes
+import time
 import urllib
 
 from paste import httpexceptions
@@ -33,11 +34,12 @@
 
     def __call__(self, environ, start_response):
         # /download/<rev_id>/<file_id>/[filename]
+        z = time.time()
 
         h = self._history
 
         args = []
-        while True:
+        while 1:
             arg = path_info_pop(environ)
             if arg is None:
                 break
@@ -63,7 +65,7 @@
             ('Content-Type', mime_type),
             ('Content-Length', len(content)),
             ('Content-Disposition',
-             "attachment; filename*=utf-8''%s" % (encoded_filename,)),
+             'attachment; filename*=utf-8\'\'%s' % encoded_filename),
             ]
         start_response('200 OK', headers)
         return [content]

=== modified file 'loggerhead/controllers/error_ui.py'
--- loggerhead/controllers/error_ui.py	2009-10-17 08:47:38 +0000
+++ loggerhead/controllers/error_ui.py	2008-12-05 18:52:44 +0000
@@ -28,19 +28,22 @@
     template_path = 'loggerhead.templates.error'
 
     def __init__(self, branch, exc_info):
-        super(ErrorUI, self).__init__(branch, lambda: None)
+        super(ErrorUI, self).__init__(branch, lambda:None)
         self.exc_info = exc_info
 
     def get_values(self, path, kwargs, response):
         exc_type, exc_object, exc_tb = self.exc_info
         description = StringIO()
         traceback.print_exception(exc_type, exc_object, None, file=description)
-        directory_breadcrumbs = util.directory_breadcrumbs(
-            self._branch.friendly_name, self._branch.is_root, 'changes')
+        directory_breadcrumbs = (
+            util.directory_breadcrumbs(
+                self._branch.friendly_name,
+                self._branch.is_root,
+                'changes'))
         return {
             'branch': self._branch,
             'error_title': ('An unexpected error occurred while'
-                            'processing the request:'),
+                            'proccesing the request:'),
             'error_description': description.getvalue(),
             'directory_breadcrumbs': directory_breadcrumbs,
         }

=== modified file 'loggerhead/controllers/filediff_ui.py'
--- loggerhead/controllers/filediff_ui.py	2009-07-07 23:52:24 +0000
+++ loggerhead/controllers/filediff_ui.py	2009-03-28 14:26:37 +0000
@@ -79,10 +79,13 @@
     template_path = 'loggerhead.templates.filediff'
 
     def get_values(self, path, kwargs, headers):
+        history = self._history
+
         revid = urllib.unquote(self.args[0])
         compare_revid = urllib.unquote(self.args[1])
         file_id = urllib.unquote(self.args[2])
 
+        repository = self._history._branch.repository
         chunks = diff_chunks_for_file(
             self._history._branch.repository, file_id, compare_revid, revid)
 

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2009-08-04 04:08:03 +0000
+++ loggerhead/controllers/revision_ui.py	2009-04-29 19:55:16 +0000
@@ -96,13 +96,13 @@
         h.add_branch_nicks(change)
 
         if '.' in change.revno:
-            # Walk "up" though the merge-sorted graph until we find a
+            # Walk "down" though the merge-sorted graph until we find a
             # revision with merge depth 0: this is the revision that merged
             # this one to mainline.
             ri = self._history._rev_info
             i = self._history._rev_indices[change.revid]
             while ri[i][0][2] > 0:
-                i -= 1
+                i += 1
             merged_in = ri[i][0][3]
         else:
             merged_in = None

=== modified file 'loggerhead/daemon.py'
--- loggerhead/daemon.py	2009-05-13 14:03:48 +0000
+++ loggerhead/daemon.py	2008-12-07 15:24:05 +0000
@@ -53,7 +53,7 @@
             pass
 
     f = open(pidfile, 'w')
-    f.write('%d\n' % (os.getpid(),))
+    f.write('%d\n' % os.getpid())
     f.close()
 
 

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2010-02-26 04:37:13 +0000
+++ loggerhead/history.py	2009-05-18 04:17:11 +0000
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2008, 2009 Canonical Ltd.
+# Copyright (C) 2008  Canonical Ltd.
 #                     (Authored by Martin Albisetti <argentina@gmail.com>)
 # Copyright (C) 2006  Robey Pointer <robey@lag.net>
 # Copyright (C) 2006  Goffredo Baroncelli <kreijack@inwind.it>
@@ -35,16 +35,36 @@
 import textwrap
 import threading
 
+from loggerhead import search
+from loggerhead import util
+from loggerhead.wholehistory import compute_whole_history_data
+
+import bzrlib
 import bzrlib.branch
 import bzrlib.delta
+import bzrlib.diff
 import bzrlib.errors
-import bzrlib.foreign
+import bzrlib.lru_cache
+import bzrlib.progress
 import bzrlib.revision
-
-from loggerhead import search
-from loggerhead import util
-from loggerhead.wholehistory import compute_whole_history_data
-
+import bzrlib.textfile
+import bzrlib.tsort
+import bzrlib.ui
+
+# bzrlib's UIFactory is not thread-safe
+uihack = threading.local()
+
+
+class ThreadSafeUIFactory (bzrlib.ui.SilentUIFactory):
+
+    def nested_progress_bar(self):
+        if getattr(uihack, '_progress_bar_stack', None) is None:
+            pbs = bzrlib.progress.ProgressBarStack(
+                      klass=bzrlib.progress.DummyProgress)
+            uihack._progress_bar_stack = pbs
+        return uihack._progress_bar_stack.get_nested()
+
+bzrlib.ui.ui_factory = ThreadSafeUIFactory()
 
 def is_branch(folder):
     try:
@@ -88,6 +108,9 @@
     return path
 
 
+# from bzrlib
+
+
 class _RevListToTimestamps(object):
     """This takes a list of revisions, and allows you to bisect by date"""
 
@@ -106,7 +129,6 @@
         return len(self.revid_list)
 
 class FileChangeReporter(object):
-
     def __init__(self, old_inv, new_inv):
         self.added = []
         self.modified = []
@@ -189,14 +211,8 @@
         """
         self._cache[key] = (revid, data)
 
-# Used to store locks that prevent multiple threads from building a 
-# revision graph for the same branch at the same time, because that can
-# cause severe performance issues that are so bad that the system seems
-# to hang.
-revision_graph_locks = {}
-revision_graph_check_lock = threading.Lock()
 
-class History(object):
+class History (object):
     """Decorate a branch to provide information for rendering.
 
     History objects are expected to be short lived -- when serving a request
@@ -234,33 +250,18 @@
         def update_missed_caches():
             for cache in missed_caches:
                 cache.set(cache_key, self.last_revid, self._rev_info)
-
-        # Theoretically, it's possible for two threads to race in creating
-        # the Lock() object for their branch, so we put a lock around
-        # creating the per-branch Lock().
-        revision_graph_check_lock.acquire()
-        try:
-            if cache_key not in revision_graph_locks:
-                revision_graph_locks[cache_key] = threading.Lock()
-        finally:
-            revision_graph_check_lock.release()
-
-        revision_graph_locks[cache_key].acquire()
-        try:
-            for cache in caches:
-                data = cache.get(cache_key, self.last_revid)
-                if data is not None:
-                    self._rev_info = data
-                    update_missed_caches()
-                    break
-                else:
-                    missed_caches.append(cache)
-            else:
-                whole_history_data = compute_whole_history_data(self._branch)
-                self._rev_info, self._rev_indices = whole_history_data
+        for cache in caches:
+            data = cache.get(cache_key, self.last_revid)
+            if data is not None:
+                self._rev_info = data
                 update_missed_caches()
-        finally:
-            revision_graph_locks[cache_key].release()
+                break
+            else:
+                missed_caches.append(cache)
+        else:
+            whole_history_data = compute_whole_history_data(self._branch)
+            self._rev_info, self._rev_indices = whole_history_data
+            update_missed_caches()
 
         if self._rev_indices is not None:
             self._revno_revid = {}
@@ -285,7 +286,7 @@
         self._branch = branch
         self._inventory_cache = {}
         self._branch_nick = self._branch.get_config().get_nickname()
-        self.log = logging.getLogger('loggerhead.%s' % (self._branch_nick,))
+        self.log = logging.getLogger('loggerhead.%s' % self._branch_nick)
 
         self.last_revid = branch.last_revision()
 
@@ -328,7 +329,7 @@
                 r.add(self._rev_info[i][0][1])
                 i += 1
             return r
-        while True:
+        while 1:
             if bzrlib.revision.is_null(revid):
                 return
             if introduced_revisions(revid) & revid_set:
@@ -341,17 +342,25 @@
     def get_short_revision_history_by_fileid(self, file_id):
         # FIXME: would be awesome if we could get, for a folder, the list of
         # revisions where items within that folder changed.i
-        possible_keys = [(file_id, revid) for revid in self._rev_indices]
-        get_parent_map = self._branch.repository.texts.get_parent_map
-        # We chunk the requests as this works better with GraphIndex.
-        # See _filter_revisions_touching_file_id in bzrlib/log.py
-        # for more information.
-        revids = []
-        chunk_size = 1000
-        for start in xrange(0, len(possible_keys), chunk_size):
-            next_keys = possible_keys[start:start + chunk_size]
-            revids += [k[1] for k in get_parent_map(next_keys)]
-        del possible_keys, next_keys
+        try:
+            # FIXME: Workaround for bzr versions prior to 1.6b3.
+            # Remove me eventually pretty please  :)
+            w = self._branch.repository.weave_store.get_weave(
+                    file_id, self._branch.repository.get_transaction())
+            w_revids = w.versions()
+            revids = [r for r in self._rev_indices if r in w_revids]
+        except AttributeError:
+            possible_keys = [(file_id, revid) for revid in self._rev_indices]
+            get_parent_map = self._branch.repository.texts.get_parent_map
+            # We chunk the requests as this works better with GraphIndex.
+            # See _filter_revisions_touching_file_id in bzrlib/log.py
+            # for more information.
+            revids = []
+            chunk_size = 1000
+            for start in xrange(0, len(possible_keys), chunk_size):
+                next_keys = possible_keys[start:start + chunk_size]
+                revids += [k[1] for k in get_parent_map(next_keys)]
+            del possible_keys, next_keys
         return revids
 
     def get_revision_history_since(self, revid_list, date):
@@ -517,7 +526,7 @@
     def get_inventory(self, revid):
         if revid not in self._inventory_cache:
             self._inventory_cache[revid] = (
-                self._branch.repository.get_inventory(revid))
+                self._branch.repository.get_revision_inventory(revid))
         return self._inventory_cache[revid]
 
     def get_path(self, revid, file_id):
@@ -571,14 +580,14 @@
             revnol = revno.split(".")
             revnos = ".".join(revnol[:-2])
             revnolast = int(revnol[-1])
-            if revnos in d:
+            if revnos in d.keys():
                 m = d[revnos][0]
                 if revnolast < m:
                     d[revnos] = (revnolast, revid)
             else:
                 d[revnos] = (revnolast, revid)
 
-        return [revid for (_, revid) in d.itervalues()]
+        return [d[revnos][1] for revnos in d.keys()]
 
     def add_branch_nicks(self, change):
         """
@@ -651,45 +660,32 @@
         Given a bzrlib Revision, return a processed "change" for use in
         templates.
         """
+        commit_time = datetime.datetime.fromtimestamp(revision.timestamp)
+
+        parents = [util.Container(revid=r,
+                   revno=self.get_revno(r)) for r in revision.parent_ids]
+
         message, short_message = clean_message(revision.message)
 
-        tags = self._branch.tags.get_reverse_tag_dict()
-
-        revtags = None
-        if tags.has_key(revision.revision_id):
-          revtags = ', '.join(tags[revision.revision_id])
+        try:
+            authors = revision.get_apparent_authors()
+        except AttributeError:
+            authors = [revision.get_apparent_author()]
 
         entry = {
             'revid': revision.revision_id,
-            'date': datetime.datetime.fromtimestamp(revision.timestamp),
-            'utc_date': datetime.datetime.utcfromtimestamp(revision.timestamp),
-            'authors': revision.get_apparent_authors(),
+            'date': commit_time,
+            'authors': authors,
             'branch_nick': revision.properties.get('branch-nick', None),
             'short_comment': short_message,
             'comment': revision.message,
             'comment_clean': [util.html_clean(s) for s in message],
             'parents': revision.parent_ids,
-            'bugs': [bug.split()[0] for bug in revision.properties.get('bugs', '').splitlines()],
-            'tags': revtags,
         }
-        if isinstance(revision, bzrlib.foreign.ForeignRevision):
-            foreign_revid, mapping = (rev.foreign_revid, rev.mapping)
-        elif ":" in revision.revision_id:
-            try:
-                foreign_revid, mapping = \
-                    bzrlib.foreign.foreign_vcs_registry.parse_revision_id(
-                        revision.revision_id)
-            except bzrlib.errors.InvalidRevisionId:
-                foreign_revid = None
-                mapping = None
-        else:
-            foreign_revid = None
-        if foreign_revid is not None:
-            entry["foreign_vcs"] = mapping.vcs.abbreviation
-            entry["foreign_revid"] = mapping.vcs.show_foreign_revid(foreign_revid)
         return util.Container(entry)
 
     def get_file_changes_uncached(self, entry):
+        repo = self._branch.repository
         if entry.parents:
             old_revid = entry.parents[0].revid
         else:
@@ -707,7 +703,7 @@
         entry.changes = changes
 
     def get_file(self, file_id, revid):
-        """Returns (path, filename, file contents)"""
+        "returns (path, filename, data)"
         inv = self.get_inventory(revid)
         inv_entry = inv[file_id]
         rev_tree = self._branch.repository.revision_tree(inv_entry.revision)
@@ -730,8 +726,8 @@
             text_changes: list((filename, file_id)),
         """
         repo = self._branch.repository
-        if (bzrlib.revision.is_null(old_revid) or
-            bzrlib.revision.is_null(new_revid)):
+        if bzrlib.revision.is_null(old_revid) or \
+               bzrlib.revision.is_null(new_revid):
             old_tree, new_tree = map(
                 repo.revision_tree, [old_revid, new_revid])
         else:
@@ -742,8 +738,8 @@
         bzrlib.delta.report_changes(new_tree.iter_changes(old_tree), reporter)
 
         return util.Container(
-            added=sorted(reporter.added, key=lambda x: x.filename),
-            renamed=sorted(reporter.renamed, key=lambda x: x.new_filename),
-            removed=sorted(reporter.removed, key=lambda x: x.filename),
-            modified=sorted(reporter.modified, key=lambda x: x.filename),
-            text_changes=sorted(reporter.text_changes, key=lambda x: x.filename))
+            added=sorted(reporter.added, key=lambda x:x.filename),
+            renamed=sorted(reporter.renamed, key=lambda x:x.new_filename),
+            removed=sorted(reporter.removed, key=lambda x:x.filename),
+            modified=sorted(reporter.modified, key=lambda x:x.filename),
+            text_changes=sorted(reporter.text_changes, key=lambda x:x.filename))

=== modified file 'loggerhead/lsprof.py'
--- loggerhead/lsprof.py	2009-07-07 23:52:24 +0000
+++ loggerhead/lsprof.py	2008-10-24 02:26:05 +0000
@@ -73,6 +73,7 @@
             d = d[:top]
         cols = "% 12s %12s %11.4f %11.4f   %s\n"
         hcols = "% 12s %12s %12s %12s %s\n"
+        cols2 = "+%12s %12s %11.4f %11.4f +  %s\n"
         file.write(hcols % ("CallCount", "Recursive", "Total(ms)",
                             "Inline(ms)", "module:lineno(function)"))
         for e in d:

=== modified file 'loggerhead/middleware/profile.py'
--- loggerhead/middleware/profile.py	2009-10-17 08:47:38 +0000
+++ loggerhead/middleware/profile.py	2009-04-01 22:50:25 +0000
@@ -1,12 +1,14 @@
-"""Profiling middleware for Paste."""
-
+'''Profiling middleware for paste.'''
+import cgi
+import logging
+import sys
 import threading
 
 from bzrlib.lsprof import profile
-
+from guppy import hpy
 
 class LSProfMiddleware(object):
-    """Paste middleware for profiling with lsprof."""
+    '''Paste middleware for profiling with lsprof.'''
 
     def __init__(self, app, global_conf=None):
         self.app = app
@@ -27,7 +29,9 @@
         try:
             ret, stats = profile(self.__run_app, environ, start_response)
             self.__count += 1
-            stats.save("%d-stats.callgrind" % (self.__count,), format="callgrind")
+            stats.save("%d-stats.callgrind" % self.__count, format="callgrind")
             return ret
         finally:
             self.lock.release()
+
+

=== modified file 'loggerhead/search.py'
--- loggerhead/search.py	2009-04-17 03:38:04 +0000
+++ loggerhead/search.py	2009-04-17 01:50:05 +0000
@@ -17,7 +17,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-
 _mod_index = None
 def import_search():
     global errors, _mod_index, FileTextHit, RevisionHit

=== modified file 'loggerhead/static/css/diff.css'
--- loggerhead/static/css/diff.css	2010-01-11 03:26:44 +0000
+++ loggerhead/static/css/diff.css	2009-02-26 20:55:46 +0000
@@ -31,7 +31,7 @@
     width:493px;
     margin:0px 0px 5px 0px;
 }
-.information, .committer, .timer, .mfrom, .mto, .revid, .bug, .tags, .foreign-svn, .foreign-git, .foreign-hg {
+.information, .committer, .timer, .mfrom, .mto, .revid {
     clear:both;
     margin:0px;
     padding:0px 0px 2px 18px;
@@ -43,11 +43,6 @@
     padding:1px 0px 0px 18px;
     margin:0px 10px 5px 0px;
 }
-.tags {
-    padding:1px 0px 0px 18px;
-    margin:0px 10px 5px 0px;
-    background:url(../images/ico_tag.gif) no-repeat top left;
-}
 .committer, .mfrom, .mto {
     color:#000;
     padding:1px 0px 0px 18px;
@@ -70,14 +65,6 @@
 .mto {
     background:url(../images/ico_mergeto.gif) no-repeat top left;
 }
-.bug {
-    padding:1px 0px 0px 18px;
-    margin:0px 10px 5px 0px;
-    float:left;
-    clear:none;
-    display:inline;
-    background:url(../images/ico_bug.png) no-repeat top left;
-}
 /**/
 #loggerheadCont p.expand, #loggerheadCont p.expand a, #loggerheadCont p.expand a:link, #loggerheadCont p.expand a:visited, #loggerheadCont p.expand a:hover {
     color:#0f6b97;

=== modified file 'loggerhead/static/css/files.css'
--- loggerhead/static/css/files.css	2009-06-17 20:28:20 +0000
+++ loggerhead/static/css/files.css	2009-01-23 20:53:40 +0000
@@ -1,5 +1,5 @@
 /*Info Box*/
-.information, .committer, .timer, .mfrom, .mto, .revid, .bug, .tags {
+.information, .committer, .timer, .mfrom, .mto, .revid {
 	float:left;
 	margin:0px 10px 5px 0px;
 	padding:0px 0px 2px 18px;
@@ -12,12 +12,6 @@
     padding:1px 0px 0px 18px;
     margin:0px 10px 5px 0px;
 }
-.tags {
-    float:left;
-    padding:1px 0px 0px 18px;
-    margin:0px 10px 5px 0px;
-    background:url(../images/ico_tag.gif) no-repeat top left;
-}
 .comiter, .mfrom, .mto {
 	color:#000;
 	padding:1px 0px 0px 18px;
@@ -45,6 +39,3 @@
     width:100%;
     position:relative;
 }
-.bug {
-	background:url(../images/ico_bug.png) no-repeat top left;
-}

=== modified file 'loggerhead/static/css/global.css'
--- loggerhead/static/css/global.css	2009-06-11 21:16:27 +0000
+++ loggerhead/static/css/global.css	2009-03-05 22:56:59 +0000
@@ -230,19 +230,13 @@
 .expandcell, .expcell {
 	width:28px;	
 }
-.summarycell, .authorcell, .tagscell, .datecell, .timedate{
+.summarycell, .authorcell, .datecell, .timedate{
   padding: 4px 8px;
   border: 1px solid #d2d2d2;
 }
 .icocell {
   width: 18px;
 }
-.authorcell, .autcell {
-  width: 240px;
-}
-.tagscell, .tagcell {
-  width: 240px;
-}
 .datecell, .date {
   width: 180px;
 }
@@ -252,7 +246,7 @@
 .downloadcell, .downr {
 	width:47px;
 }
-.revnro, .expcell, .diffr, .summcell, .autcell, .tagcell, .icocell, .date, .downr, .allicones, .timedate2 {
+.revnro, .expcell, .diffr, .summcell, .autcell, .icocell, .date, .downr, .allicones, .timedate2 {
   border: 0;
   padding: 4px 4px;
   border-bottom:1px solid #d2d2d2;
@@ -351,4 +345,4 @@
 }
 .revision_log {
     overflow: hidden;
-}
+}
\ No newline at end of file

=== removed file 'loggerhead/static/images/ico_bug.png'
Binary files loggerhead/static/images/ico_bug.png and loggerhead/static/images/ico_bug.png differ
=== removed file 'loggerhead/static/images/ico_tag.gif'
Binary files loggerhead/static/images/ico_tag.gif and loggerhead/static/images/ico_tag.gif differ
=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2009-10-17 08:47:38 +0000
+++ loggerhead/templatefunctions.py	2009-04-28 03:01:54 +0000
@@ -13,15 +13,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-
 import cgi
 import os
-
-import pkg_resources
-
-import bzrlib
-
-import loggerhead
 from loggerhead.zptsupport import zpt
 
 
@@ -56,7 +49,7 @@
                     url, entry.revno, filename, '#' + filename)
     else:
         def file_link(filename):
-            return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>' % (
+            return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>'%(
                 url(['/revision', entry.revno]), '#' + filename, cgi.escape(filename),
                 cgi.escape(entry.revno), cgi.escape(filename))
     return _pt('revisionfilechanges').expand(
@@ -100,7 +93,7 @@
         extra = ' ' + entry.branch_nick
     else:
         extra = ''
-    return '(%s%s)' % (entry.revno, extra)
+    return '(%s%s)'%(entry.revno, extra)
 
 
 @templatefunc
@@ -122,84 +115,11 @@
 
 @templatefunc
 def annotate_link(url, revno, path):
-    return '<a href="%s" title="Annotate %s">%s</a>' % (
+    return '<a href="%s" title="Annotate %s">%s</a>'%(
         url(['/annotate', revno, path]), cgi.escape(path), cgi.escape(path))
 
 @templatefunc
 def revision_link(url, revno, path, frag=''):
-    return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>' % (
+    return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>'%(
         url(['/revision', revno, path]), frag, cgi.escape(path),
         cgi.escape(revno), cgi.escape(path))
-
-
-@templatefunc
-def loggerhead_version():
-    return loggerhead.__version__
-
-_cached_generator_string = None
-
-@templatefunc
-def generator_string():
-    global _cached_generator_string
-    if _cached_generator_string is None:
-        versions = []
-
-        # TODO: Errors -- e.g. from a missing/invalid __version__ attribute, or
-        # ValueError accessing Distribution.version -- should be non-fatal.
-
-        versions.append(('Loggerhead', loggerhead.__version__))
-
-        import sys
-        python_version = bzrlib._format_version_tuple(sys.version_info)
-        versions.append(('Python', python_version))
-
-        versions.append(('Bazaar', bzrlib.__version__))
-
-        Paste = pkg_resources.get_distribution('Paste')
-        versions.append(('Paste', Paste.version))
-
-        try:
-            PasteDeploy = pkg_resources.get_distribution('PasteDeploy')
-        except pkg_resources.DistributionNotFound:
-            pass
-        else:
-            versions.append(('PasteDeploy', PasteDeploy.version))
-
-        import simpletal
-        versions.append(('SimpleTAL', simpletal.__version__))
-
-        try:
-            import pygments
-        except ImportError:
-            pass
-        else:
-            versions.append(('Pygments', pygments.__version__))
-
-        try:
-            from bzrlib.plugins import search
-        except ImportError:
-            pass
-        else:
-            bzr_search_version = bzrlib._format_version_tuple(
-                search.version_info)
-            versions.append(('bzr-search', bzr_search_version))
-
-        # TODO: On old Python versions, elementtree may be used.
-
-        try:
-            import simplejson
-        except ImportError:
-            pass
-        else:
-            versions.append(('simplejson', simplejson.__version__))
-
-        try:
-            Dozer = pkg_resources.get_distribution('Dozer')
-        except pkg_resources.DistributionNotFound:
-            pass
-        else:
-            versions.append(('Dozer', Dozer.version))
-
-        version_strings = ("%s/%s" % t for t in versions)
-        _cached_generator_string = ' '.join(version_strings)
-    return _cached_generator_string

=== modified file 'loggerhead/templates/atom.pt'
--- loggerhead/templates/atom.pt	2009-06-06 12:23:11 +0000
+++ loggerhead/templates/atom.pt	2009-03-06 09:57:54 +0000
@@ -3,19 +3,17 @@
   <title>
     bazaar changes for <tal:branch-name content="branch/friendly_name">branch name</tal:branch-name>
   </title>
-  <updated tal:content="string:${updated}Z">${updated}</updated>
+  <updated tal:content="updated">${updated}</updated>
   <id tal:content="python:branch.url(['/atom'])">url</id>
-  <link rel="self" type="application/atom+xml" tal:attributes="href python:branch.url(['/atom'])" />
-  <link rel="alternate" type="text/html" tal:attributes="href python:branch.url(['/changes'])" />
+  <link rel="self" tal:attributes="href python:branch.url([''])" />
 
   <entry tal:repeat="entry changes">
-    <title tal:content="string:${entry/revno}: ${entry/short_comment}">
+    <title tal:content="string: ${entry/revno}: ${entry/short_comment}">
       ${entry/revno}: ${entry/short_comment}
     </title>
-    <updated tal:content="string:${entry/utc_date/isoformat}Z">
-      updated
+    <updated tal:content="entry/date/isoformat">
+    Z
     </updated>
-    <!-- TODO: The feed validator will generate warnings because this is URL-encoded -->
     <id tal:content="python:branch.url(['/revision', entry.revno])">
       ID
     </id>
@@ -27,7 +25,7 @@
     <content type="text" tal:content="entry/comment">
       comment
     </content>
-    <link rel="alternate" type="text/html"
+    <link rel="alternate"
           tal:attributes="href python:branch.url(['/revision', entry.revno])" />
   </entry>
 </feed>

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2009-07-21 21:52:59 +0000
+++ loggerhead/templates/changelog.pt	2009-03-31 21:15:48 +0000
@@ -73,7 +73,6 @@
           <td class="expandcell show_if_js">&nbsp;</td>
           <td class="summarycell">Summary</td>
           <td class="authorcell">Authors</td>
-          <td tal:condition="show_tag_col" class="tagscell">Tags</td>
           <td class="datecell">Date</td>
           <td class="diffcell">Diff</td>
           <td class="downloadcell">Files</td>
@@ -95,16 +94,12 @@
             </td>
             <td class="summcell">
               <div class="short_description">
-                <img tal:condition="python:entry.parents[1:]"
-                     tal:attributes="src python:branch.static_url('/static/images/ico_mergefrom.gif')" />
                 <a tal:attributes="title python:'Show revision '+entry.revno;
                                    href  python:url(['/revision', entry.revno], clear=1);
                                    class string:link"
                    tal:content="entry/short_comment"></a>
               </div>
               <div class="long_description" style="display: none">
-                <img tal:condition="python:entry.parents[1:]"
-                     tal:attributes="src python:branch.static_url('/static/images/ico_mergefrom.gif')" />
                 <a tal:attributes="title python:'Show revision '+entry.revno;
                                    href  python:url(['/revision', entry.revno], clear=1);
                                    class string:link"
@@ -116,8 +111,6 @@
             </td>
             <td tal:content="python:util.trunc(util.hide_email(entry.authors[0]), 20)"
                 class="autcell"></td>
-            <td tal:condition="show_tag_col" tal:content="string:${entry/tags}"
-                class="tagcell"></td>
             <td class="date">
               <span tal:attributes="title python:util.date_time(entry.date)"
                     tal:content="python:util._approximatedate(entry.date)"></span>

=== modified file 'loggerhead/templates/directory.pt'
--- loggerhead/templates/directory.pt	2009-11-27 00:14:35 +0000
+++ loggerhead/templates/directory.pt	2008-10-18 00:23:09 +0000
@@ -22,10 +22,10 @@
           
           <tr class="blueRow0" tal:condition="python:name != '/'">
             <td class="icocell">
-                <a href="../"><img tal:attributes="src python:static_url('/static/images/ico_folder_up.gif')" /></a>
+                <a href=".."><img tal:attributes="src python:static_url('/static/images/ico_folder_up.gif')" /></a>
             </td>
             <td class="summcell" colspan="3">
-                <a href="../">..</a>
+                <a href="..">..</a>
             </td>
           </tr>
           <tal:block repeat="dir dirs">
@@ -50,12 +50,12 @@
             <tal:non-branch-row tal:condition="not:dir/branch">
               <tr tal:attributes="class string:blueRow${dir/parity}">
                 <td class="icocell">
-                    <a tal:attributes="href string:${dir/dirname}/">
+                    <a tal:attributes="href string:${dir/dirname}">
                         <img tal:attributes="src python:static_url('/static/images/ico_folder.gif')" alt="Folder" />
                     </a>
                 </td>
                 <td class="autcell">
-                  <a tal:attributes="href string:${dir/dirname}/" tal:content="dir/dirname" /></td>
+                  <a tal:attributes="href string:${dir/dirname}" tal:content="dir/dirname" /></td>
                 <td class="date"></td>
                 <td class="date" tal:content="dir/last_change"></td>
               </tr>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2009-07-15 22:02:09 +0000
+++ loggerhead/templates/inventory.pt	2009-02-10 04:25:11 +0000
@@ -90,7 +90,7 @@
             <!-- Show this if it's a symlink -->
             <tr tal:attributes="class string:blueRow${repeat/file/even}" tal:condition="python:file.kind=='symlink'">
                 <td class="autcell"><a tal:attributes="href python:url(['/annotate', change.revno, file.absolutepath])">
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_flecha.gif')" alt="Symlink" />
+                        <img tal:attributes="src python:branch.static_url('/static/images/ico_flecha.gif')" alt="Symlink" />
                     </a>
 
                  <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])" 

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2009-06-24 02:35:46 +0000
+++ loggerhead/templates/macros.pt	2009-04-07 18:26:03 +0000
@@ -3,8 +3,6 @@
 <html xmlns="http://www.w3.org/1999/xhtml" metal:define-macro="main">
   <head>
     <meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
-    <meta name="generator"
-          tal:attributes="content generator_string" />
 
     <title metal:define-slot="title"></title>
     <link rel="stylesheet"
@@ -61,7 +59,7 @@
         <h1 metal:define-slot="heading"></h1>
         <div metal:define-slot="content"></div>
 
-        <p class="fl">Loggerhead <tal:version content="loggerhead_version" /> is a web-based interface for <a href="http://bazaar-vcs.org/">Bazaar</a> branches</p>
+        <p class="fl">Loggerhead is a web-based interface for <a href="http://bazaar-vcs.org/">Bazaar</a> branches</p>
       </div>
   </body>
 </html>

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2010-01-11 03:26:44 +0000
+++ loggerhead/templates/revisioninfo.pt	2009-04-28 03:01:54 +0000
@@ -18,15 +18,6 @@
             <tal:b content="merged_in"/></a>.
         </div>
         <div class="revid" tal:content="string:Revision ID: ${change/revid}"></div>
-	<div tal:attributes="class string:foreign-${change/foreign_vcs}"
-	     tal:condition="change/foreign_vcs" 
-	     tal:repeat="revid_part python:change.foreign_revid.keys()"
-	     tal:content="python:'%s: %s' % (revid_part, change.foreign_revid[revid_part])"/>
-        <div class="tags" tal:condition="change/tags" tal:content="string:Tags: ${change/tags}"></div>
-        <div class="clear"><!-- --></div>
-        <div class="bug" tal:repeat="bug change/bugs">
-            <a tal:attributes="href bug" tal:content="bug"></a>
-        </div>
         <div class="information" tal:content="structure python:util.fixed_width(change.comment)"></div>
     </div>
     <ul id="list-files" tal:condition="file_changes">

=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2009-06-08 23:02:49 +0000
+++ loggerhead/tests/test_simple.py	2009-05-27 12:44:28 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd.
+# Copyright (C) 2008, 2009  Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -121,7 +121,7 @@
 
 
 class TestEmptyBranch(BasicTests):
-    """Test that an empty branch doesn't break"""
+    """ Test that an empty branch doesn't break"""
 
     def setUp(self):
         BasicTests.setUp(self)
@@ -156,18 +156,3 @@
         app = self.setUpLoggerhead()
         res = app.get('/changes', status=404)
 
-
-#class TestGlobalConfig(BasicTests):
-#    """
-#    Test that global config settings are respected
-#    """
-
-#    def setUp(self):
-#        BasicTests.setUp(self)
-#        self.createBranch()
-#        config.GlobalConfig().set_user_option('http_version', 'True')
-
-#    def test_setting_respected(self):
-        #FIXME: Figure out how to test this properly
-#        app = self.setUpLoggerhead()
-#        res = app.get('/changes', status=200)

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2009-11-26 03:44:40 +0000
+++ loggerhead/util.py	2009-04-02 20:32:12 +0000
@@ -19,6 +19,13 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+try:
+    from xml.etree import ElementTree as ET
+except ImportError:
+    from elementtree import ElementTree as ET
+
+from simpletal.simpleTALUtils import HTMLStructureCleaner
+
 import base64
 import cgi
 import datetime
@@ -31,13 +38,6 @@
 import os
 import subprocess
 
-try:
-    from xml.etree import ElementTree as ET
-except ImportError:
-    from elementtree import ElementTree as ET
-
-from simpletal.simpleTALUtils import HTMLStructureCleaner
-
 log = logging.getLogger("loggerhead.controllers")
 
 
@@ -129,7 +129,7 @@
     return _wrap_with_date_time_title(date, _displaydate(date))
 
 
-class Container(object):
+class Container (object):
     """
     Convert a dict into an object with attributes.
     """
@@ -217,6 +217,8 @@
 
     return: the same value recieved if not empty, and a '&nbsp;' if it is.
     """
+
+
     if s is None:
         return '&nbsp;'
     elif isinstance(s, int):
@@ -314,7 +316,7 @@
 
     out = str(base)
     if (base < 100) and (dot != 0):
-        out += '.%d' % (dot,)
+        out += '.%d' % (dot)
     if divisor == KILO:
         out += 'K'
     elif divisor == MEG:
@@ -382,6 +384,8 @@
     """
     # Is our root directory itself a branch?
     if is_root:
+        if view == 'directory':
+            directory = 'files'
         breadcrumbs = [{
             'dir_name': path,
             'path': '',
@@ -461,7 +465,7 @@
         now = time.time()
         msec = int(now * 1000) % 1000
         timestr = time.strftime('%Y%m%d%H%M%S',
-                                time.localtime(now)) + ('%03d' % (msec,))
+                                time.localtime(now)) + ('%03d' % msec)
         filename = f.__name__ + '-' + timestr + '.lsprof'
         cPickle.dump(stats, open(filename, 'w'), 2)
         return ret
@@ -533,7 +537,7 @@
     _reloader_environ_key = 'PYTHON_RELOADER_SHOULD_RUN'
 
     @classmethod
-    def _turn_sigterm_into_systemexit(cls):
+    def _turn_sigterm_into_systemexit(self):
         """
         Attempts to turn a SIGTERM exception into a SystemExit exception.
         """
@@ -547,26 +551,26 @@
         signal.signal(signal.SIGTERM, handle_term)
 
     @classmethod
-    def is_installed(cls):
-        return os.environ.get(cls._reloader_environ_key)
+    def is_installed(self):
+        return os.environ.get(self._reloader_environ_key)
 
     @classmethod
-    def install(cls):
+    def install(self):
         from paste import reloader
         reloader.install(int(1))
 
     @classmethod
-    def restart_with_reloader(cls):
+    def restart_with_reloader(self):
         """Based on restart_with_monitor from paste.script.serve."""
         print 'Starting subprocess with file monitor'
-        while True:
+        while 1:
             args = [sys.executable] + sys.argv
             new_environ = os.environ.copy()
-            new_environ[cls._reloader_environ_key] = 'true'
+            new_environ[self._reloader_environ_key] = 'true'
             proc = None
             try:
                 try:
-                    cls._turn_sigterm_into_systemexit()
+                    self._turn_sigterm_into_systemexit()
                     proc = subprocess.Popen(args, env=new_environ)
                     exit_code = proc.wait()
                     proc = None
@@ -575,7 +579,7 @@
                     return 1
             finally:
                 if (proc is not None
-                    and getattr(os, 'kill', None) is not None):
+                    and hasattr(os, 'kill')):
                     import signal
                     try:
                         os.kill(proc.pid, signal.SIGTERM)
@@ -587,20 +591,3 @@
             if exit_code != 3:
                 return exit_code
             print '-'*20, 'Restarting', '-'*20
-
-
-def convert_file_errors(application):
-    """WSGI wrapper to convert some file errors to Paste exceptions"""
-    def new_application(environ, start_response):
-        try:
-            return application(environ, start_response)
-        except (IOError, OSError), e:
-            import errno
-            from paste import httpexceptions
-            if e.errno == errno.ENOENT:
-                raise httpexceptions.HTTPNotFound()
-            elif e.errno == errno.EACCES:
-                raise httpexceptions.HTTPForbidden()
-            else:
-                raise
-    return new_application

=== modified file 'loggerhead/wholehistory.py'
--- loggerhead/wholehistory.py	2009-10-21 14:40:23 +0000
+++ loggerhead/wholehistory.py	2009-05-18 04:17:11 +0000
@@ -1,5 +1,4 @@
-#
-# Copyright (C) 2008, 2009 Canonical Ltd.
+# Cache the whole history data needed by loggerhead about a branch.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,7 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-"""Cache the whole history data needed by loggerhead about a branch."""
 
 import logging
 import time
@@ -32,7 +30,7 @@
     # Filter ghosts, and null:
     if NULL_REVISION in revision_graph:
         del revision_graph[NULL_REVISION]
-    for key, parents in revision_graph.iteritems():
+    for key, parents in revision_graph.items():
         revision_graph[key] = tuple(parent for parent in parents if parent
             in revision_graph)
     return revision_graph
@@ -48,11 +46,11 @@
     last_revid = branch.last_revision()
 
     log = logging.getLogger('loggerhead.%s' %
-                            (branch.get_config().get_nickname(),))
+                            branch.get_config().get_nickname())
 
     graph = branch.repository.get_graph()
-    parent_map = dict((key, value) for key, value in
-        graph.iter_ancestry([last_revid]) if value is not None)
+    parent_map = dict(((key, value) for key, value in
+         graph.iter_ancestry([last_revid]) if value is not None))
 
     _revision_graph = _strip_NULL_ghosts(parent_map)
 
@@ -72,7 +70,7 @@
         _rev_indices[revid] = len(_rev_info)
         _rev_info.append([(seq, revid, merge_depth, revno_str, end_of_merge), (), parents])
 
-    for revid in _revision_graph.iterkeys():
+    for revid in _revision_graph.keys():
         if _rev_info[_rev_indices[revid]][0][2] == 0:
             continue
         for parent in _revision_graph[revid]:
@@ -80,6 +78,6 @@
             if revid not in c[1]:
                 c[1] = c[1] + (revid,)
 
-    log.info('built revision graph cache: %r secs' % (time.time() - z,))
+    log.info('built revision graph cache: %r secs' % (time.time() - z))
 
     return (_rev_info, _rev_indices)

=== removed file 'serve-branches'
--- serve-branches	2009-06-26 09:42:43 +0000
+++ serve-branches	1970-01-01 00:00:00 +0000
@@ -1,27 +0,0 @@
-#!/usr/bin/env python
-#
-# Copyright (C) 2008, 2009 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Search for branches underneath a directory and serve them all."""
-
-import sys
-
-from loggerhead.main import main
-
-
-if __name__ == "__main__":
-    main(sys.argv[1:])

=== renamed file 'loggerhead/main.py' => 'serve-branches' (properties changed: -x to +x)
--- loggerhead/main.py	2009-11-27 18:30:24 +0000
+++ serve-branches	2009-05-04 20:21:08 +0000
@@ -1,6 +1,4 @@
-#
-# Copyright (C) 2008, 2009 Canonical Ltd
-#
+#!/usr/bin/env python
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
@@ -22,6 +20,7 @@
 import sys
 
 from bzrlib.plugin import load_plugins
+from bzrlib.transport import get_transport
 
 from paste import httpserver
 from paste.httpexceptions import HTTPExceptionHandler, HTTPInternalServerError
@@ -35,31 +34,47 @@
 from loggerhead.apps.error import ErrorHandlerApp
 
 
-def get_config_and_path(args):
-    config = LoggerheadConfig(args)
+def main(args):
+    config = LoggerheadConfig()
 
     if config.get_option('show_version'):
-        print "loggerhead %s" % (__version__,)
+        print "loggerhead %s" % __version__
         sys.exit(0)
 
     if config.arg_count > 1:
         config.print_help()
         sys.exit(1)
     elif config.arg_count == 1:
-        base = config.get_arg(0)
-    else:
-        base = '.'
-
-    if not config.get_option('allow_writes'):
-        base = 'readonly+' + base
-
-    return config, base
-
-
-def setup_logging(config):
+        path = config.get_arg(0)
+    else:
+        path = '.'
+
+    load_plugins()
+
+    transport = get_transport(path)
+
+    if config.get_option('trunk_dir') and not config.get_option('user_dirs'):
+        print "--trunk-dir is only valid with --user-dirs"
+        sys.exit(1)
+
+    if config.get_option('reload'):
+        if Reloader.is_installed():
+            Reloader.install()
+        else:
+            return Reloader.restart_with_reloader()
+
+    if config.get_option('user_dirs'):
+        if not config.get_option('trunk_dir'):
+            print "You didn't specify a directory for the trunk directories."
+            sys.exit(1)
+        app = UserBranchesFromTransportRoot(transport, config)
+    else:
+        app = BranchesFromTransportRoot(transport, config)
+
+    # setup_logging()
     logging.basicConfig()
     logging.getLogger('').setLevel(logging.DEBUG)
-    logger = logging.getLogger('loggerhead')
+    logger = getattr(app, 'log', logging.getLogger('loggerhead'))
     if config.get_option('log_folder'):
         logfile_path = os.path.join(
             config.get_option('log_folder'), 'serve-branches.log')
@@ -71,30 +86,10 @@
     logfile.setFormatter(formatter)
     logfile.setLevel(logging.DEBUG)
     logger.addHandler(logfile)
-    return logger
-
-
-def make_app_for_config_and_path(config, base):
-    if config.get_option('trunk_dir') and not config.get_option('user_dirs'):
-        print "--trunk-dir is only valid with --user-dirs"
-        sys.exit(1)
-
-    if config.get_option('reload'):
-        if Reloader.is_installed():
-            Reloader.install()
-        else:
-            return Reloader.restart_with_reloader()
-
-    if config.get_option('user_dirs'):
-        if not config.get_option('trunk_dir'):
-            print "You didn't specify a directory for the trunk directories."
-            sys.exit(1)
-        app = UserBranchesFromTransportRoot(base, config)
-    else:
-        app = BranchesFromTransportRoot(base, config)
-
-    setup_logging(config)
-
+
+    # setup_logging() #end
+
+    app = TransLogger(app, logger=logger)
     if config.get_option('profile'):
         from loggerhead.middleware.profile import LSProfMiddleware
         app = LSProfMiddleware(app)
@@ -129,17 +124,6 @@
 
     app = HTTPExceptionHandler(app)
     app = ErrorHandlerApp(app)
-    app = TransLogger(app, logger=logging.getLogger('loggerhead'))
-
-    return app
-
-
-def main(args):
-    load_plugins()
-
-    config, path = get_config_and_path(args)
-
-    app = make_app_for_config_and_path(config, path)
 
     if not config.get_option('user_port'):
         port = '8080'
@@ -151,21 +135,8 @@
     else:
         host = config.get_option('user_host')
 
-    if not config.get_option('protocol'):
-        protocol = 'http'
-    else:
-        protocol = config.get_option('protocol')
-
-    if protocol == 'http':
-        httpserver.serve(app, host=host, port=port)
-    else:
-        if protocol == 'fcgi':
-            from flup.server.fcgi import WSGIServer
-        elif protocol == 'scgi':
-            from flup.server.scgi import WSGIServer
-        elif protocol == 'ajp':
-            from flup.server.ajp import WSGIServer
-        else:
-            print 'Unknown protocol: %s.' % (protocol)
-            sys.exit(1)
-        WSGIServer(app, bindAddress=(host, int(port))).run()
+    httpserver.serve(app, host=host, port=port)
+
+
+if __name__ == "__main__":
+    main(sys.argv)

=== modified file 'setup.py' (properties changed: +x to -x)
--- setup.py	2009-10-17 06:19:40 +0000
+++ setup.py	2008-11-20 16:55:47 +0000
@@ -18,8 +18,8 @@
 
 """Loggerhead is a web viewer for projects in bazaar"""
 
+
 from distutils.core import setup
-
 import loggerhead
 
 
@@ -34,9 +34,7 @@
     packages = ["loggerhead",
                 "loggerhead/apps",
                 "loggerhead/controllers",
-                "loggerhead/templates",
-                "bzrlib.plugins.loggerhead"],
-    package_dir={'bzrlib.plugins.loggerhead':'.'},
+                "loggerhead/templates"],
     package_data = {"loggerhead": ["templates/*.pt",
                                    "static/css/*.css",
                                    "static/javascript/*.js",

=== modified file 'start-loggerhead'
--- start-loggerhead	2009-10-17 06:35:33 +0000
+++ start-loggerhead	2009-02-19 01:24:20 +0000
@@ -13,13 +13,11 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""
-WARNING! This script has been deprecated and will go away soon!
-A script for starting the loggerhead process.
-"""
+"""A script for starting the loggerhead process."""
 
 
 import logging
+import logging.handlers
 from optparse import OptionParser
 import os
 import sys
@@ -34,18 +32,11 @@
 
 from loggerhead import daemon
 from loggerhead.apps.config import Root
-from loggerhead.trace import setup_logging
+from loggerhead.trace import make_handler, setup_logging
 from loggerhead.apps.error import ErrorHandlerApp
 
 
 def main():
-    sys.stderr.write('\n\n')
-    sys.stderr.write('WARNING!!! This script has been deprecated by '
-                     'serve-branches, and will be removed in the next '
-                     'release. Please migrate to serve-branches and report '
-                     'any missing features.\n')
-    sys.stderr.write('\n\n')
-
     home = os.path.realpath(os.path.dirname(__file__))
     default_pidfile = os.path.join(home, 'loggerhead.pid')
     default_configfile = os.path.join(home, 'loggerhead.conf')
@@ -102,7 +93,7 @@
     if not options.foreground:
         sys.stderr.write('\n')
         sys.stderr.write('Launching loggerhead into the background.\n')
-        sys.stderr.write('PID file: %s\n' % (options.pidfile,))
+        sys.stderr.write('PID file: %s\n' % options.pidfile)
         sys.stderr.write('\n')
 
         daemon.daemonize(options.pidfile, home)

=== modified file 'stop-loggerhead'
--- stop-loggerhead	2009-05-13 14:03:48 +0000
+++ stop-loggerhead	2008-10-24 02:26:05 +0000
@@ -32,7 +32,7 @@
 try:
     f = open(options.pidfile, 'r')
 except IOError, e:
-    print 'Pid file %s not found.' % (options.pidfile,)
+    print 'Pid file %s not found.' % options.pidfile
     sys.exit(1)
 
 pid = int(f.readline())
@@ -44,7 +44,7 @@
     sys.exit(1)
 
 print
-print 'Shutting down previous server @ pid %d.' % (pid,)
+print 'Shutting down previous server @ pid %d.' % pid
 print
 
 import signal

